Unit FmEvoOptionsSrc;

interface

uses
  EvoStoreSrc,
  sysutils, Windows, Classes, Forms, Controls,graphics,
  StdCtrls, Buttons, ComCtrls, ExtCtrls, Spin, Dialogs;

type
  TFmEvoOptions = class(TForm)
    ButtonPanel: TPanel;
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    PageControl: TPageControl;
    TabSheetGameOptions: TTabSheet;
    TabSheetCreatureProperties: TTabSheet;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Label16: TLabel;
    CheckIsAPlant: TCheckBox;
    Panel1: TPanel;
    SrcLabel: TLabel;
    DstLabel: TLabel;
    IncludeBtn: TSpeedButton;
    IncAllBtn: TSpeedButton;
    ExcludeBtn: TSpeedButton;
    ExcAllBtn: TSpeedButton;
    SrcList: TListBox;
    DstList: TListBox;
    Label23: TLabel;
    TabSheet3: TTabSheet;
    Label8: TLabel;
    Edit_HistColor: TEdit;
    Edit_Description: TEdit;
    Edit_DisplayName: TEdit;
    Label5: TLabel;
    Spin_BitmapIndex: TSpinEdit;
    Label6: TLabel;
    Label7: TLabel;
    BtnSelImage: TBitBtn;
    Image1: TImage;
    BtnSelHistcolor: TBitBtn;
    GroupBox2: TGroupBox;
    Check_ShowSex: TCheckBox;
    Check_ShowEnergy: TCheckBox;
    Check_CreatShowActivity: TCheckBox;
    Check_ShowPartner: TCheckBox;
    Shape1: TShape;
    Label12: TLabel;
    Spin_StartingCount: TSpinEdit;
    Track_StepSize: TTrackBar;
    GroupBox5: TGroupBox;
    Label17: TLabel;
    Label18: TLabel;
    Track_Minenergy: TTrackBar;
    Track_Maxenergy: TTrackBar;
    GroupBox6: TGroupBox;
    Label20: TLabel;
    Spin_Influencedistance: TSpinEdit;
    Label21: TLabel;
    Spin_Numberchildren: TSpinEdit;
    Spin_Energy: TSpinEdit;
    Label19: TLabel;
    Spin_StepSize: TSpinEdit;
    Spin_Minenergy: TSpinEdit;
    Spin_Maxenergy: TSpinEdit;
    Label13: TLabel;
    BtnApply: TBitBtn;
    PageControl2: TPageControl;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    Label3: TLabel;
    Spin_MaximumNumberOfCreatures: TSpinEdit;
    GroupBox3: TGroupBox;
    Label15: TLabel;
    Label2: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Check_VertScroll: TCheckBox;
    Spin_VertScrollStep: TSpinEdit;
    Check_HorizScroll: TCheckBox;
    Spin_HorizScrollStep: TSpinEdit;
    Combo_VertScrollDirUp: TComboBox;
    Combo_HorizScrollDirLeft: TComboBox;
    GroupBox4: TGroupBox;
    Label11: TLabel;
    Check_AutoRecreate: TCheckBox;
    Spin_AutoRecreateStableIterations: TSpinEdit;
    Check_Evolution: TCheckBox;
    Panel2: TPanel;
    Label4: TLabel;
    ComboBox1: TComboBox;
    BtnHelp: TBitBtn;
    BtnAbout: TBitBtn;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    ShapeTextColor: TShape;
    BtnSelTextColor: TBitBtn;
    ShapeLineColor: TShape;
    BtnSelLineColor: TBitBtn;
    Shape4: TShape;
    BtnSelBackColor: TBitBtn;
    ShapeBackColor: TShape;
    BtnPropagate: TBitBtn;
    Track_saverdelay: TTrackBar;
    Label14: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    GroupBox1: TGroupBox;
    Check_Showlegend: TCheckBox;
    Check_ShowActivity: TCheckBox;
    Check_ShowCensus: TCheckBox;
    Check_ShowHistory: TCheckBox;
    Panel3: TPanel;
    Label1: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Track_TimerTick: TTrackBar;
    Label31: TLabel;
    Label32: TLabel;
    Panel4: TPanel;
    EatenByList: TListBox;
    Label33: TLabel;
    BtnDefaults: TBitBtn;
    procedure OKBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ComboBox1DrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure IncludeBtnClick(Sender: TObject);
    procedure ExcludeBtnClick(Sender: TObject);
    procedure IncAllBtnClick(Sender: TObject);
    procedure ExcAllBtnClick(Sender: TObject);
    procedure DstListClick(Sender: TObject);
    procedure CheckIsAPlantClick(Sender: TObject);
    procedure BtnSelImageClick(Sender: TObject);
    procedure BtnSelHistcolorClick(Sender: TObject);
    procedure Check_VertScrollClick(Sender: TObject);
    procedure Check_HorizScrollClick(Sender: TObject);
    procedure Check_AutoRecreateClick(Sender: TObject);
    procedure Track_StepSizeChange(Sender: TObject);
    procedure Track_MinenergyChange(Sender: TObject);
    procedure Track_MaxenergyChange(Sender: TObject);
    procedure BtnAboutClick(Sender: TObject);
    procedure BtnHelpClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure BtnSelBackColorClick(Sender: TObject);
    procedure BtnSelTextColorClick(Sender: TObject);
    procedure BtnSelLineColorClick(Sender: TObject);
    procedure BtnPropagateClick(Sender: TObject);
    procedure Edit_DisplayNameChange(Sender: TObject);
    procedure BtnApplyClick(Sender: TObject);
    procedure Spin_MinenergyChange(Sender: TObject);
    procedure Check_ShowActivityClick(Sender: TObject);
    procedure PageControl2Change(Sender: TObject);
    procedure Spin_MaxenergyChange(Sender: TObject);
    procedure Spin_StepSizeChange(Sender: TObject);
    procedure Check_ShowSexClick(Sender: TObject);
    procedure BtnDefaultsClick(Sender: TObject);
  private
    { Private declarations }
     intrnalcall, okpictchoose, st : boolean;
     fFormImageNdx : Integer;
     aform : tform;
     fUniquelImageList : tlist;
     OlDCreName : string;
     OwnerDrawbmp : tbitmap;

     Function GetCreatureProperties : TCreatureProperties;
     Procedure SetCreatureProperties(ACreatureProperties : TCreatureProperties);
     function EvoCreatureCount : Integer;
    procedure MoveSelected(List: TCustomListBox; Items: TStrings);
    procedure SetItem(List: TListBox; Index: Integer);
    function GetFirstSelection(List: TCustomListBox): Integer;
    procedure SetButtons;
    procedure UpdateCreatureStores;
    procedure ScrollSpeedEnabled;
    procedure SpeedButton2Click(Sender: TObject);
    procedure ImageFormPaint(Sender: TObject);
    procedure ImageFormPaintCanvas(aCanvas : TCanvas; mw, mh, xs, ys : integer);
    procedure ImageFormMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure TrackChange(aTrackBar : TTrackBar; aSpinEdit : TSpinEdit);
    Function CheckUniquelImageList(anindex : integer) : integer;
    procedure FillUniquelImageList;
    Procedure SetControlLimits;

 protected
   procedure CreateParams(var Params:TCreateParams); override;
   Property CreatureProperties : TCreatureProperties Read GetCreatureProperties Write SetCreatureProperties;
   Property FormImageNdx : Integer Read fFormImageNdx Write fFormImageNdx;

  public
    { Public declarations }

  end;

var
  FmEvoOptions: TFmEvoOptions;

implementation
{$R *.DFM}

uses
  cybmanip,
  dmodule,
  cybabou3;

var
    maxsaverdelay, lfy, lfx : integer;

procedure TFmEvoOptions.FormCreate(Sender: TObject);
Var
   lc : integer;

begin
    ReadRegistry;
    SetControlLimits;
    intrnalcall := false;
    dy := 32;
    dx := dy;
    dx2 := dx div 2;
    maxsaverdelay := 21;
    fUniquelImageList := tlist.create;
    stdrect := rect(0,0, dx2, dx2);
    OwnerDrawbmp := tbitmap.create;
    OwnerDrawbmp.width := dx2;
    OwnerDrawbmp.height := dx2;
    SrcList.items.clear;
    ComboBox1.items.clear;
    for lc := GSOgre to GSBlueBird do with CreatureStores[lc] do begin
           ComboBox1.items.addobject(DisplayName, pointer(lc));
    end;
    ComboBox1.dropdowncount := succ(GSBlueBird);
    ComboBox1.itemindex := SaverOptions.CreatureSelected;
    OlDCreName := ComboBox1.items[ComboBox1.itemindex];
    ComboBox1Change( nil);
    with PageControl do begin
      activepage := pages[SaverOptions.DialogPage];
      images := imagelist;
    end;
    with PageControl1 do begin
      activepage := pages[SaverOptions.CreaturePage];
      images := imagelist;
    end;
    with PageControl2 do begin
      activepage := pages[SaverOptions.OptionsPage];
      images := imagelist;
    end;
    PageControl2Change( nil);
end;

procedure TFmEvoOptions.FormDestroy(Sender: TObject);
begin
       fUniquelImageList.free;
       SaverOptions.CreatureSelected := ComboBox1.itemindex;
       OwnerDrawbmp.free;
       with PageControl do SaverOptions.DialogPage := activepage.pageindex;
       with PageControl1 do SaverOptions.CreaturePage := activepage.pageindex;
       with PageControl2 do SaverOptions.OptionsPage := activepage.pageindex;
end;

procedure TFmEvoOptions.FormShow(Sender: TObject);

begin
    st := true;
    with SaverOptions do begin
      Track_TimerTick.Position := TimerTick;
      Spin_MaximumNumberOfCreatures.Value := MaximumNumberOfCreatures;
      Check_ShowCensus.checked := ShowCensus;
      Check_ShowLegend.checked := ShowLegend;
      Check_ShowHistory.checked := ShowHistory;
      Check_ShowActivity.checked := ShowActivity;
      ShapeBackColor.brush.color := BackgroundColor;
      ShapeTextColor.brush.color := TextColor;
      ShapeLineColor.brush.color := LineColor;
      Check_VertScroll.checked := VertScroll;
      Spin_VertScrollStep.Value := VertScrollStep;
      Combo_VertScrollDirUp.itemindex := ord(VertScrollDirUp);
      Check_HorizScroll.checked := HorizScroll;
      Spin_HorizScrollStep.Value := HorizScrollStep;
      Combo_HorizScrollDirLeft.itemindex := ord(HorizScrollDirLeft);
      Check_AutoRecreate.checked := AutoRecreate;
      Spin_AutoRecreateStableIterations.Value := AutoRecreateStableIterations;
      Track_saverdelay.position := (maxsaverdelay  - saverdelay);
      Check_Evolution.checked := Evolution;
      Check_VertScrollClick(nil);
      Check_HorizScrollClick(nil);
      Check_AutoRecreateClick(nil);
    end;
    st := false;
end;

procedure TFmEvoOptions.UpdateCreatureStores;
Var
   atmpbmp : graphics.tbitmap;

begin
    atmpbmp := CreatureStores[SaverOptions.CreatureSelected].graphic;
    CreatureStores[SaverOptions.CreatureSelected] := CreatureProperties;
    CreatureStores[SaverOptions.CreatureSelected].graphic := atmpbmp;
end;

procedure TFmEvoOptions.OKBtnClick(Sender: TObject);

begin
    UpdateCreatureStores;
    with SaverOptions do begin
      TimerTick := Track_TimerTick.Position;
      MaximumNumberOfCreatures := Spin_MaximumNumberOfCreatures.Value;
      ShowCensus := Check_ShowCensus.checked;
      ShowLegend := Check_ShowLegend.checked;
      ShowHistory := Check_ShowHistory.checked;
      ShowActivity := Check_ShowActivity.checked;
      ShowLine := Showlegend or ShowCensus or ShowHistory or ShowActivity;
      BackgroundColor := ShapeBackColor.brush.color;
      TextColor := ShapeTextColor.brush.color;
      LineColor := ShapeLineColor.brush.color;
      VertScroll := Check_VertScroll.checked;
      VertScrollStep := Spin_VertScrollStep.Value;
      VertScrollDirUp := (Combo_VertScrollDirUp.itemindex = 1);
      HorizScroll := Check_HorizScroll.checked;
      HorizScrollStep := Spin_HorizScrollStep.Value;
      HorizScrollDirLeft := (Combo_HorizScrollDirLeft.itemindex = 1);
      AutoRecreate := Check_AutoRecreate.checked;
      AutoRecreateStableIterations := Spin_AutoRecreateStableIterations.Value;
      Evolution := Check_Evolution.checked;
      saverdelay :=  (maxsaverdelay  - Track_saverdelay.position);
    end;
    close;
end;

function CombineStringsinLine(splitstr : string; aplist : tstrings) : string;
var
   lc, mc : integer;

begin
   result := '';
   mc := pred(aplist.count);
   for lc := 0 to mc do begin
     if (aplist[lc] <> '') then begin
         if (lc < mc) then result := result +aplist[lc]+splitstr
                      else result := result +aplist[lc];
     end;
   end;
end;

procedure Split_lineStr(line : string; splitstr : string; aplist : tstrings);
var
  lstr,tpos : byte;
  dstr : string;

begin
   lstr := length(splitstr);
   tpos := pos(splitstr,line);
   aplist.clear;
   while (tpos <> 0) do begin
       dstr := copy(line,1,pred(tpos));
       aplist.add(dstr);
       delete(line,1,tpos+pred(lstr));
       tpos := pos(splitstr,line);
   end;
   if (line <> '') then aplist.add(line);
end;

Function TFmEvoOptions.GetCreatureProperties : TCreatureProperties;
Begin
    with result do begin
      StartingCount := Spin_StartingCount.Value;
      Geneset := ComboBox1.Itemindex;
      Stepsize := Track_Stepsize.position;
      if CheckIsAPlant.checked then begin
        Stepsize := -1*abs(Stepsize);
        foodlist := '';
      end;
      Energy := Spin_Energy.Value;
      Minenergy := Spin_MinEnergy.Value;
      Maxenergy := Spin_MaxEnergy.Value;
      Numberchildren := Spin_Numberchildren.Value;
      Influencedistance := Spin_Influencedistance.Value;
      DisplayName := Edit_DisplayName.Text;
      Description := Edit_Description.Text;
      HistColor := Edit_HistColor.Text;
          try
            if identtocolor(Histcolor, Bitmapindex) then HistColorVal := tcolor(Bitmapindex)
                                                    else HistColorVal := stringtocolor(Histcolor);
          except
            HistColorVal := clAqua;
          end;
      BitmapIndex := Spin_BitmapIndex.Value;
      ShowSex := Check_ShowSex.checked;
      ShowEnergy := Check_ShowEnergy.checked;
      ShowActivity := Check_CreatShowActivity.checked;
      ShowPartner := Check_ShowPartner.checked;
      Foodlist := CombineStringsinLine(',',DstList.items);
    end;
End;

Procedure TFmEvoOptions.SetControlLimits;
begin
      Track_Minenergy.max := maxMinenergy;
      Track_Maxenergy.max := maxMaxenergy;
      Spin_Numberchildren.maxValue := maxNumberchildren;
      Spin_Influencedistance.maxValue := maxInfluencedistance;
      Spin_StartingCount.maxValue := maxStartingCount;
      Spin_Energy.maxValue := maxEnergy;
      Spin_Stepsize.maxValue := maxStepsize;
      Track_Minenergy.min := minMinenergy;
      Track_Maxenergy.min := minMaxenergy;
      Spin_Numberchildren.minValue := minNumberchildren;
      Spin_Influencedistance.minValue := minInfluencedistance;
      Spin_StartingCount.minValue := minStartingCount;
      Spin_Energy.minValue := minEnergy;
      Spin_Stepsize.minValue := minStepsize;
end;

Procedure TFmEvoOptions.SetCreatureProperties(ACreatureProperties : TCreatureProperties);
Var
   mc, lc : integer;

Begin
    with ACreatureProperties do begin
      Spin_StartingCount.Value := StartingCount;
      Track_Stepsize.position := abs(Stepsize);
      Spin_Stepsize.Value := Track_Stepsize.position;
      CheckIsAPlant.checked := (Stepsize < 0);
      Spin_Energy.Value := Energy;
      Track_Minenergy.position := Minenergy;
      Track_Maxenergy.position := Maxenergy;
      Spin_Numberchildren.Value := Numberchildren;
      Spin_Influencedistance.Value := Influencedistance;
      Edit_DisplayName.Text := DisplayName;
      Label13.Caption := DisplayName+'s';
      Edit_Description.Text := Description;
      Spin_BitmapIndex.Value := BitmapIndex;
      image1.canvas.rectangle(0,0,image1.width, image1.height);
      imagelist.getbitmap( Spin_BitmapIndex.Value, Image1.picture.bitmap);
      Edit_HistColor.Text := HistColor;
      Edit_HistColor.font.color := HistColorVal;
      Shape1.brush.color := histcolorval;
      Check_ShowSex.checked := ShowSex;
      Check_ShowEnergy.checked := ShowEnergy;
      Check_CreatShowActivity.checked := ShowActivity;
      Check_ShowPartner.checked := ShowPartner;
      Split_lineStr(Foodlist,',', DstList.items);
      mc := pred(DstList.items.count);
      lc := 0;
      while (lc <= mc) do begin
           if (ComboBox1.items.indexof(DstList.items[lc]) <> -1) then inc(lc)
           else begin
              DstList.items.delete(lc);
              dec(mc);
           end;
      end;
      SrcList.items.clear;
      EatenByList.items.clear;
      for lc := GSOgre to GSBlueBird do with CreatureStores[lc] do begin
          mc := DstList.items.indexof(DisplayName);
          if (mc = -1) then begin
            SrcList.items.addobject(DisplayName, pointer(lc));
          end
          else begin
             DstList.items.objects[mc] := pointer(lc);
          end;
          if (pos(ACreatureProperties.Displayname, foodlist) > 0) then begin
            EatenByList.items.addobject(DisplayName, pointer(lc));
          end;
      end;
      setbuttons;
      BtnApply.enabled := false;
      BtnPropagate.enabled := false;
    end;
End;

procedure TFmEvoOptions.ComboBox1DrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);

var
  aind, tx, ty : Integer;
  aCanvas : TCanvas;
  astrings : tstrings;
const
  lhgap = 6;

begin
  aCanvas := nil;
  if (Control is TComboBox) then with TComboBox(Control) do begin
    aCanvas := canvas;
    astrings := items;
  end;
  if (Control is TListBox) then with TListBox(Control) do begin
    aCanvas := canvas;
    astrings := items;
  end;
  if acanvas = nil then exit;
  if (astrings[index] = '') then exit;
  with aCanvas do begin
    FillRect(Rect);
    ty := Rect.topleft.y;
    tx := Rect.topleft.x+lhgap;
    OwnerDrawbmp.canvas.fillrect(stdrect);
    aind := integer(astrings.objects[index]);
    imagelist.getbitmap( CreatureStores[aind].bitmapindex, OwnerDrawbmp);
    draw(tx, ty, OwnerDrawbmp);
    tx := tx+dx2+lhgap;
    textout(tx, ty, astrings[Index]);
  end;
end;

procedure TFmEvoOptions.ComboBox1Change(Sender: TObject);
Var
   lc : integer;
   bstr, astr : string;
   tb : boolean;

begin
  tb := false;
  if (SaverOptions.CreatureSelected <> ComboBox1.Itemindex) and (SaverOptions.CreatureSelected in [GSOgre .. GSBlueBird]) then begin
    UpdateCreatureStores;
    bstr := CreatureStores[SaverOptions.CreatureSelected].DisplayName;
    tb := (bstr <> OlDCreName);
  end;
  if not(ComboBox1.Itemindex in [GSOgre .. GSBlueBird]) then exit;
  CreatureProperties := CreatureStores[ComboBox1.Itemindex];
  astr := CreatureStores[ComboBox1.Itemindex].DisplayName;
  SaverOptions.CreatureSelected := ComboBox1.Itemindex;
  if tb then begin
       ComboBox1.items.clear;
       for lc := GSOgre to GSBlueBird do with CreatureStores[lc] do begin
           ComboBox1.items.addobject(DisplayName, pointer(lc));
           Foodlist := replacestring(OlDCreName, bstr, Foodlist);
       end;
       ComboBox1.Itemindex := SaverOptions.CreatureSelected;
  end;
  OlDCreName := astr;
end;

procedure TFmEvoOptions.BtnApplyClick(Sender: TObject);
Var
   lc, mc : integer;
   astr, bstr : string;

begin
   astr := CreatureStores[SaverOptions.CreatureSelected].displayname;
   UpdateCreatureStores;
   bstr := CreatureStores[SaverOptions.CreatureSelected].displayname;
   ComboBox1.items.clear;
   for lc := GSOgre to GSBlueBird do with CreatureStores[lc] do begin
        ComboBox1.items.addobject(DisplayName, pointer(lc));
   end;
   mc := DstList.items.indexof(astr);
   if (mc <> -1) then DstList.items[mc] := bstr
   else begin
       mc := SrcList.items.indexof(astr);
       if (mc <> -1) then SrcList.items[mc] := bstr;
       ComboBox1.itemindex := SaverOptions.CreatureSelected;
   end;
   BtnApply.enabled := false;
end;

function TFmEvoOptions.EvoCreatureCount : Integer;
Var
   lc : integer;

begin
   result := 0;
   for lc := GSOgre to GSBlueBird do begin
       inc(result,  CreatureStores[lc].Startingcount);
   end;
end;

procedure TFmEvoOptions.IncludeBtnClick(Sender: TObject);
var
  Index: Integer;
begin
  Index := GetFirstSelection(SrcList);
  MoveSelected(SrcList, DstList.Items);
  SetItem(SrcList, Index);
end;

procedure TFmEvoOptions.ExcludeBtnClick(Sender: TObject);
var
  Index: Integer;
begin
  Index := GetFirstSelection(DstList);
  MoveSelected(DstList, SrcList.Items);
  SetItem(DstList, Index);
end;

procedure TFmEvoOptions.IncAllBtnClick(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to SrcList.Items.Count - 1 do
    DstList.Items.AddObject(SrcList.Items[I],      SrcList.Items.Objects[I]);
  SrcList.Items.Clear;
  SetItem(SrcList, 0);
end;

procedure TFmEvoOptions.ExcAllBtnClick(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to DstList.Items.Count - 1 do
    SrcList.Items.AddObject(DstList.Items[I], DstList.Items.Objects[I]);
  DstList.Items.Clear;
  SetItem(DstList, 0);
end;

procedure TFmEvoOptions.MoveSelected(List: TCustomListBox; Items: TStrings);
var
  I: Integer;
begin
  for I := List.Items.Count - 1 downto 0 do
    if List.Selected[I] and (items.indexof(List.Items[I]) = -1) then begin
       Items.AddObject(List.Items[I], List.Items.Objects[I]);
       List.Items.Delete(I);
    end;
end;

procedure TFmEvoOptions.SetButtons;
var
  SrcEmpty, DstEmpty: Boolean;
begin
  SrcEmpty := SrcList.Items.Count = 0;
  DstEmpty := DstList.Items.Count = 0;
  IncludeBtn.Enabled := not SrcEmpty;
  IncAllBtn.Enabled := not SrcEmpty;
  ExcludeBtn.Enabled := not DstEmpty;
  ExcAllBtn.Enabled := not DstEmpty;
end;

function TFmEvoOptions.GetFirstSelection(List: TCustomListBox): Integer;
Var
   mc : integer;

begin
  mc := pred(List.Items.count);
  for Result := 0 to mc do if List.Selected[Result] then Exit;
  Result := LB_ERR;
end;

procedure TFmEvoOptions.SetItem(List: TListBox; Index: Integer);
var
  MaxIndex: Integer;
begin
  with List do begin
    SetFocus;
    MaxIndex := List.Items.Count - 1;
    if Index = LB_ERR then Index := 0
    else if Index > MaxIndex then Index := MaxIndex;
    Selected[Index] := True;
  end;
  SetButtons;
end;

procedure TFmEvoOptions.DstListClick(Sender: TObject);
begin
    SetButtons;
end;

procedure TFmEvoOptions.CheckIsAPlantClick(Sender: TObject);
Var
   lc : integer;

begin
   panel1.visible := not(CheckIsAPlant.checked);
   Label23.visible := not(panel1.visible);
   if CheckIsAPlant.checked then begin
      DstList.items.clear;
      SrcList.items.clear;
      for lc := GSOgre to GSBlueBird do with CreatureStores[lc] do begin
            SrcList.items.addobject(DisplayName, pointer(lc));
      end;
   end;
end;


procedure TFmEvoOptions.CreateParams(var Params:TCreateParams);
begin
  inherited CreateParams(Params);
  if  ConfigParent = 0 then exit;
  with Params do begin
    WndParent := ConfigParent;
  end;
end;

procedure TFmEvoOptions.SpeedButton2Click(Sender: TObject);
var
   abtn1, abtn2 : tbitbtn;
   apanel : tpanel;

begin
  aform := TForm.create(nil);
  with aform do begin
     Try
          FillUniquelImageList;
          caption := 'Bitmaps';
          visible := false;
          onpaint := ImageFormPaint;
          onresize := ImageFormPaint;
          onMouseUp := ImageFormMouseUp;
          clientwidth := 465;
          clientheight := 295;
          apanel := tpanel.create(aform);
          with apanel do begin
              parent := aform;
              align := alBottom;
              color := clBtnFAce;
              height := 35;
          end;
          abtn1 := tbitbtn.create(aform);
          with abtn1 do begin
              parent := apanel;
              top := 5;
              left := 100;
              kind := bkOk;
          end;
          abtn2 := tbitbtn.create(aform);
          with abtn2 do begin
              parent := apanel;
              top := 5;
              left := 300;
              kind := bkCancel;
          end;
          position := poScreencenter;
          lfx := -1;
          lfy := -1;
          showmodal;
          okpictchoose := (modalresult = mrOK);
     Finally
            free;
     end;
  end;
end;

procedure TFmEvoOptions.ImageFormPaint(Sender: TObject);

begin
  ImageFormPaintCanvas(aform.canvas, aform.clientwidth, aform.clientheight, 1, 1);
end;

const
 chsp : integer = 15;
 cvsp : integer = 2;
 il : integer = 5;
 it : integer = 10;
 bmps = 32;

procedure TFmEvoOptions.ImageFormPaintCanvas(aCanvas : TCanvas; mw, mh,  xs, ys : integer);
Var
   fui, hsp, vsp, tm, cw, ch, ct, cl, lc, mc : integer;
   abmp : tbitmap;

begin
   hsp := xs*chsp;
   vsp := ys*cvsp;
   ct := ys*it;
   cl := xs*il;
   cw := xs*bmps;
   ch := ys*bmps;
   with imagelist do begin
       mc := pred(count);
       aCanvas.brush.color := SaverOptions.Backgroundcolor;
       aCanvas.font.color := SaverOptions.textcolor;
       aCanvas.FillRect(Rect(0,0,mw,mh));
       for lc := 0 to mc do begin
             abmp := tbitmap.create;
             getbitmap( lc, abmp);
             with aCanvas do begin
                fui := CheckUniquelImageList(lc);
                if (lc = FormImageNdx) or (fui = -1) then begin
                     if (lc = FormImageNdx) then begin
                           abmp.transparent := false;
                           pen.color := SaverOptions.Linecolor;
                           pen.width := 6;
                           rectangle(  cl-1, ct-1, cl+cw+1, ct+ch+1);
                           lfx := cl;
                           lfy := ct;
                     end
                     else abmp.transparent := true;
                     stretchdraw( rect( cl, ct, cl+cw, ct+ch), abmp);
                end
                else begin
                    TextOut(cl, ct+vsp, 'Used');
                end;
             end;
             tm := (cl+cw+hsp);
             if (tm+hsp <= mw) then begin
                cl := tm;
             end
             else begin
                 cl := xs*il;
                 inc(ct, ch+vsp);
             end;
             abmp.free;
       end;
     end;
end;

procedure TFmEvoOptions.ImageFormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
Var
   hsp, vsp, tm, cw, ch, ct, cl, lc, mc : integer;
   xs, ys : integer;
   abmp : tbitmap;

begin
   xs := 1;
   ys := 1;
   hsp := xs*chsp;
   vsp := ys*cvsp;
   ct := ys*it;
   cl := xs*il;
   cw := xs*bmps;
   ch := ys*bmps;
   with imagelist do begin
       mc := pred(count);
       for lc := 0 to mc do begin
             if (((X > cl) and (X < (cl+cw)))
                and ((y > ct) and (Y < (ct+ch)))) then begin
                with aform.Canvas do begin
                 if (CheckUniquelImageList(lc) = -1) then begin
                    if ((lfx <> -1) and (lfy <> -1)) then begin
                     pen.color := SaverOptions.Backgroundcolor;
                     pen.width := 6;
                     rectangle(  lfx-1, lfy-1, lfx+cw+1, lfy+ch+1);
                     abmp := tbitmap.create;
                     getbitmap( FormImageNdx, abmp);
                     abmp.transparent := true;
                     stretchdraw( rect( lfx, lfy, lfx+cw, lfy+ch), abmp);
                     abmp.free;
                   end;
                   pen.color := SaverOptions.LineCOlor;
                   pen.width := 6;
                   rectangle(  cl-1, ct-1, cl+cw+1, ct+ch+1);
                   abmp := tbitmap.create;
                   getbitmap( lc, abmp);
                   stretchdraw( rect( cl, ct, cl+cw, ct+ch), abmp);
                   abmp.free;
                   lfx := cl;
                   lfy := ct;
                   FormImageNdx := lc;
                   exit;
                 end
                 else messagebeep(0);
                end;
             end;
             tm := (cl+cw+hsp);
             if (tm+hsp <= aform.clientwidth) then begin
                cl := tm;
             end
             else begin
                 cl := xs*il;
                 inc(ct, ch+vsp);
             end;
       end;
     end;
end;

procedure TFmEvoOptions.FillUniquelImageList;
Var
   tc, lc : integer;

begin
   fUniquelImageList.clear;
   for lc := GSOgre to GSBlueBird do begin
       tc := CreatureStores[lc].Bitmapindex;
       if (tc <> FormImageNdx) then fUniquelImageList.add( pointer(tc));
   end;
end;

Function TFmEvoOptions.CheckUniquelImageList(anindex : integer) : integer;
Var
   tc, lc, mc : integer;

begin
   result :=  -1;
   mc := pred(fUniquelImageList.count);
   for lc := 0 to mc do begin
       tc := integer(fUniquelImageList[lc]);
       if (anindex = tc) then begin
           result := lc;
           exit;
       end;
   end;
end;

procedure TFmEvoOptions.BtnSelImageClick(Sender: TObject);

begin
   FormImageNdx := Spin_BitmapIndex.Value;
   SpeedButton2Click(nil);
   if okpictchoose then begin
     Spin_BitmapIndex.Value := FormImageNdx;
     image1.canvas.rectangle(0,0,image1.width, image1.height);
     imagelist.getbitmap( Spin_BitmapIndex.Value, Image1.picture.bitmap);
     creaturestores[combobox1.itemindex].bitmapindex := FormImageNdx;
   end;
end;

procedure TFmEvoOptions.BtnSelHistcolorClick(Sender: TObject);
var
  acolor : tcolor;

begin
  acolor := stringtocolor(Edit_HistColor.text);
  acolor := datamod.getcolor(aCOLOR);
  Edit_HistColor.text := colortostring(aCOLOR);
  Edit_HistColor.font.color := aCOLOR;
  Shape1.brush.color := aCOLOR;
end;

procedure TFmEvoOptions.Check_VertScrollClick(Sender: TObject);

begin
  Label15.enabled := Check_VertScroll.checked;
  Spin_VertScrollStep.enabled := Check_VertScroll.checked;
  Label9.enabled := Check_VertScroll.checked;
  Combo_VertScrollDirUp.enabled := Check_VertScroll.checked;
  ScrollSpeedEnabled;
end;

procedure TFmEvoOptions.Check_HorizScrollClick(Sender: TObject);

begin
   Label2.enabled := Check_HorizScroll.checked;
   Spin_HorizScrollStep.enabled := Check_HorizScroll.checked;
   Label10.enabled := Check_HorizScroll.checked;
   Combo_HorizScrollDirLeft.enabled := Check_HorizScroll.checked;
   ScrollSpeedEnabled;
end;

procedure TFmEvoOptions.Check_AutoRecreateClick(Sender: TObject);

begin
  Spin_AutoRecreateStableIterations.enabled := Check_AutoRecreate.checked;
  Label11.enabled := Check_AutoRecreate.checked;
  Check_Evolution.enabled := Check_AutoRecreate.checked;
end;

procedure TFmEvoOptions.TrackChange(aTrackBar : TTrackBar; aSpinEdit : TSpinEdit);

begin
  if intrnalcall then exit;
  intrnalcall := true;
  aSpinEdit.value := aTrackBar.position;
  intrnalcall := false;
end;

procedure TFmEvoOptions.Track_StepSizeChange(Sender: TObject);

begin
  TrackChange( Track_StepSize, Spin_StepSize);
end;

procedure TFmEvoOptions.Track_MinenergyChange(Sender: TObject);

begin
  TrackChange( Track_Minenergy, Spin_Minenergy);
end;

procedure TFmEvoOptions.Track_MaxenergyChange(Sender: TObject);

begin
  TrackChange( Track_Maxenergy, Spin_Maxenergy);
end;

procedure TFmEvoOptions.BtnAboutClick(Sender: TObject);
Var
   aabbmp : tbitmap;

begin
  aabbmp := tbitmap.create;
  aabbmp.LoadFromResourceName( HInstance, 'ABOUTBMP');
  CybAboutBox := TCybAboutBox.create(self);
  with CybAboutBox do begin
   Try
      ICONBMP := aabbmp;
      setbmpsize;
      prodnametext := TitleString+' !';
      yeartext := '1999';
      Boxcaptiontext := TitleString;
      versiontext := '32 bit Version 0 (April 2000)';
      vercommenttext := 'A Simple Life Simulator Screen Saver.'#13'Thanks to Sven George and Meik Weber for the password handling code';
      execute;
   Finally
    aabbmp.free;
    free;
   end;
  end;
end;

procedure TFmEvoOptions.BtnHelpClick(Sender: TObject);

begin
   Application.HelpCommand(HELP_INDEX, 0);
end;

procedure TFmEvoOptions.CancelBtnClick(Sender: TObject);

begin
  close;
end;

procedure TFmEvoOptions.BtnSelBackColorClick(Sender: TObject);

begin
  ShapeBackColor.brush.color := datamod.getcolor(ShapeBackColor.brush.color);
end;


procedure TFmEvoOptions.BtnSelTextColorClick(Sender: TObject);

begin
  ShapeTextColor.brush.color := datamod.getcolor(ShapeTextColor.brush.color);
end;

procedure TFmEvoOptions.BtnSelLineColorClick(Sender: TObject);

begin
  ShapeLineColor.brush.color := datamod.getcolor(ShapeLineColor.brush.color);
end;

procedure TFmEvoOptions.BtnPropagateClick(Sender: TObject);
Var
   lc : integer;

begin
       for lc := GSOgre to GSBlueBird do with CreatureStores[lc] do begin
           ShowSex := Check_ShowSex.checked;
           ShowEnergy := Check_ShowEnergy.checked;
           ShowActivity := Check_CreatShowActivity.checked;
           ShowPartner := Check_ShowPartner.checked;
       end;
end;

procedure TFmEvoOptions.Edit_DisplayNameChange(Sender: TObject);

begin
  BtnApply.enabled := true;
end;

procedure TFmEvoOptions.ScrollSpeedEnabled;
var
  tb :  boolean;

begin
  tb := Check_VertScroll.checked or Check_HorizScroll.checked;
  Label14.enabled := tb;
  Label29.enabled := tb;
  Label30.enabled := tb;
  Track_saverdelay.enabled := tb;
end;

procedure TFmEvoOptions.Spin_MinenergyChange(Sender: TObject);

begin
   if intrnalcall then exit;
   Spin_Energy.minValue := Spin_Minenergy.value;
   Spin_Energy.Value := greatint(Spin_Energy.Value, Spin_Minenergy.value);
   intrnalcall := true;
   Track_Minenergy.position := Spin_Minenergy.value;
   intrnalcall := false;
end;

procedure TFmEvoOptions.Spin_MaxenergyChange(Sender: TObject);

begin
   if intrnalcall then exit;
   intrnalcall := true;
   Track_Maxenergy.position := Spin_Maxenergy.value;
   intrnalcall := false;
end;

procedure TFmEvoOptions.Spin_StepSizeChange(Sender: TObject);

begin
   if intrnalcall then exit;
   intrnalcall := true;
   Track_StepSize.position := Spin_StepSize.value;
   intrnalcall := false;
end;

procedure TFmEvoOptions.Check_ShowActivityClick(Sender: TObject);
var
   tmpSaverOptions : TSaverOptions;

begin
    with tmpSaverOptions do begin
      ShowCensus := Check_ShowCensus.checked;
      ShowLegend := Check_ShowLegend.checked;
      ShowHistory := Check_ShowHistory.checked;
      ShowActivity := Check_ShowActivity.checked;
      ShowLine := Showlegend or ShowCensus or ShowHistory or ShowActivity;
      Label27.enabled := ShowLine;
      BtnSelTextColor.enabled := ShowLine;
      ShapeTextColor.enabled := ShowLine;
      Label28.enabled := ShowLine;
      BtnSelLineColor.enabled := ShowLine;
      ShapeLineColor.enabled := ShowLine;
    end;
end;

procedure TFmEvoOptions.PageControl2Change(Sender: TObject);

begin
   BtnApplyClick(nil);
   Label32.caption := inttostr(EvoCreatureCount);
end;

procedure TFmEvoOptions.Check_ShowSexClick(Sender: TObject);
begin
  BtnPropagate.enabled := true;
end;

procedure TFmEvoOptions.BtnDefaultsClick(Sender: TObject);
Var
   lc, mc : integer;

begin
  saveroptions := defsaveroptions;
  for lc := GSOgre to GSBlueBird do begin
      CreatureStores[lc]:= DefCreatureStores[lc];
  end;
  FormShow( nil);
  ComboBox1Change( nil);
  ComboBox1.items.clear;
  for lc := GSOgre to GSBlueBird do begin
      with CreatureStores[lc] do ComboBox1.items.addobject(DisplayName, pointer(lc));
  end;
  ComboBox1.itemindex := SaverOptions.CreatureSelected;
  OlDCreName := ComboBox1.items[ComboBox1.itemindex];
end;

{ End of code  }
end.


